VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Encrypted program by The trick"
   ClientHeight    =   4470
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmMain.frx":0000
   ScaleHeight     =   298
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   297
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrFrame 
      Interval        =   32
      Left            =   2280
      Top             =   2640
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' // frmMain.frm - test form for encrypt/decrypt module
' //  Krivous Anatoly Anatolevich (The trick), 2016

Option Explicit

Private Type RGBQUAD
    rgbBlue         As Byte
    rgbGreen        As Byte
    rgbRed          As Byte
    rgbReserved     As Byte
End Type

Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Private Type BITMAPINFO
    bmiHeader       As BITMAPINFOHEADER
    bmiColors       As RGBQUAD
End Type

Private Declare Function SetDIBitsToDevice Lib "gdi32" ( _
                         ByVal hdc As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal dx As Long, _
                         ByVal dy As Long, _
                         ByVal SrcX As Long, _
                         ByVal SrcY As Long, _
                         ByVal Scan As Long, _
                         ByVal NumScans As Long, _
                         ByRef bits As Any, _
                         ByRef BitsInfo As BITMAPINFO, _
                         ByVal wUsage As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" ( _
                         ByVal aHDC As Long, _
                         ByVal hBitmap As Long, _
                         ByVal nStartScan As Long, _
                         ByVal nNumScans As Long, _
                         ByRef lpBits As Any, _
                         ByRef lpBI As BITMAPINFO, _
                         ByVal wUsage As Long) As Long

Private Const pi = 3.1415926

Dim bits()      As Long
Dim newBits()   As Long
Dim bi          As BITMAPINFO

Private Sub Form_Load()
    
    bi.bmiHeader.biSize = Len(bi.bmiHeader)
    
    If GetDIBits(Me.hdc, Me.Picture.Handle, 0, 0, ByVal 0&, bi, 0) Then
        
        bi.bmiHeader.biBitCount = 32
        ReDim bits(bi.bmiHeader.biWidth - 1, bi.bmiHeader.biHeight - 1)
        ReDim newBits(bi.bmiHeader.biWidth - 1, bi.bmiHeader.biHeight - 1)
        
        GetDIBits Me.hdc, Me.Picture.Handle, 0, bi.bmiHeader.biHeight, bits(0, 0), bi, 0
        
    End If
    
End Sub

Private Sub tmrFrame_Timer()
    Dim x       As Long:    Dim y       As Long
    Dim dx      As Single:  Dim dy      As Single
    Dim rx      As Single:  Dim ry      As Single
    Dim nx      As Long:    Dim ny      As Long
    Dim ph      As Single:  Dim ph2     As Single
    Dim ofst    As Single:  Dim rad     As Single
    
    Static phase    As Long
    
    ph = phase / 10
    ph2 = Abs(Sin(phase / 100))
    
    For y = 0 To bi.bmiHeader.biHeight - 1
        dy = y / bi.bmiHeader.biHeight - 0.5
        For x = 0 To bi.bmiHeader.biWidth - 1
            dx = x / bi.bmiHeader.biWidth - 0.5
            
            rad = Sqr(dx * dx + dy * dy)
            If rad > 1 Then rad = 1
            
            ofst = Abs(Sin(rad * 10 + ph) * Cos(rad * 10 + ph) * (ph2 - rad))
            If ofst > 1 Then ofst = 1 Else If ofst < 0 Then ofst = 0
            
            rx = dx * Cos(ph / 10) - dy * Sin(ph / 10)
            ry = dx * Sin(ph / 10) + dy * Cos(ph / 10)
            
            nx = (rx + 0.5 + ofst * rx * ((rad - 1) / 0.5)) * (bi.bmiHeader.biWidth - 1)
            ny = (ry + 0.5 + ofst * ry * ((rad - 1) / 0.5)) * (bi.bmiHeader.biHeight - 1)
            
            nx = Abs(nx Mod bi.bmiHeader.biWidth)
            ny = Abs(ny Mod bi.bmiHeader.biHeight)
            
            newBits(x, y) = bits(nx, ny)
            
        Next
    Next
    
    phase = phase + 1
    
    SetDIBitsToDevice Me.hdc, 0, 0, bi.bmiHeader.biWidth, bi.bmiHeader.biHeight, 0, 0, 0, bi.bmiHeader.biHeight, newBits(0, 0), bi, 0
    
End Sub
